###########################################################################
#
# Bowe Strickland <bowe@yak.net> 
# $Id: PodChannel.py,v 1.7 2005/12/10 10:40:35 bowe Exp $
#
###########################################################################

from Products.CMFCore.CMFCorePermissions import View
from Products.Archetypes.public import *
from AccessControl import ClassSecurityInfo
from config import PROJECTNAME

# encapsulation of RSS XML
from XMLPodChannel import XMLPodChannel


class PodFolder(BaseFolder):

	meta_type = 'PodFolder'
	archetype_name = 'Pod Folder'
	schema = BaseFolderSchema
	allowed_content_types = ['PodFolder', 'PodChannel', ]

	_at_rename_after_creation = True

	actions = (
		{
			'id': 'update',
			'name': 'Update',
			'action': 'string:${object_url}/podchannel_update',
			'permissions': (View,),
			'category': 'object',
		},	
		{
			'id': 'view',
			'name': 'View',
			'action': 'string:${object_url}/podfolder_view',
			'permissions': (View,),
			'category': 'object',
		},	
	)

	security = ClassSecurityInfo()

	security.declareProtected(View, 'update')
	def update(self, *args):
		for i in self.listFolderContents(): i.update()
 
registerType(PodFolder)

class PodChannel(BaseContent):

	typeDescription = ("""
		A Simple Pod Channel 
	""")

	meta_type = 'PodChannel'
	archetype_name = 'Pod Channel'
	content_icon = 'podchannel_icon.gif'

	_at_rename_after_creation = True

	actions = (
		{
			'id': 'update',
			'name': 'Update',
			'action': 'string:${object_url}/podchannel_update',
			'permissions': (View,),
			'category': 'object',
		},	
		{
			'id': 'view',
			'name': 'View',
			'action': 'string:${object_url}/podchannel_view',
			'permissions': (View,),
			'category': 'object',
		},	
	)
	
	schema = BaseSchema + Schema((
		StringField('url', 
			required=1, 
			accessor="get_url",
			widget=StringWidget(size=80,
				description="URL of RSS feed for this channel",
				label="RSS URL",)
		),
	))	

	security = ClassSecurityInfo()

	security.declareProtected(View, 'update')
	def update(self, *args):

		pc = XMLPodChannel(self.url)
		self.rss = pc.reduce_to_hash()
		if self.rss.has_key("title"): self.title = self.rss["title"]["content"]
		if self.rss.has_key("item"):
			self.nitems = len(self.rss["item"])
		else: self.nitems = 0

		self.raw_download_list = pc.get_suggested_filenames()

registerType(PodChannel, PROJECTNAME)


#
# vi: ts=4
#

